/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// TimeInstant A temporal entity with zero extent or duration
type TimeInstant interface {
	TimeTemporalEntity
	timeInXSDDateTimeStampSingleTime
	timeInXSDgYearMonthSingleTime
	timeInTemporalPositionSingleTimeTemporalPosition
	timeInXSDDateTimeSingleTime
	timeInXSDDateSingleTime
	timeInDateTimeSingleTimeGeneralDateTimeDescription
	timeInXSDgYearSingleTime
	timeInTimePositionSingleTimePosition
	IsTimeInstant() bool // indicates base class
}

// sTimeInstant A temporal entity with zero extent or duration
type sTimeInstant struct {
	sTimeTemporalEntity
	propTimeInXSDDateTimeStampBaseGoTimeTypeGoTimeSingleGoTime
	propTimeInXSDgYearMonthBaseGoTimeTypeGoTimeSingleGoTime
	propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition
	propTimeInXSDDateTimeBaseGoTimeTypeGoTimeSingleGoTime
	propTimeInXSDDateBaseGoTimeTypeGoTimeSingleGoTime
	propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription
	propTimeInXSDgYearBaseGoTimeTypeGoTimeSingleGoTime
	propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition
}

// NewTimeInstant creates a new TimeInstant
func (mod *Model) NewTimeInstant(iri string) (ret TimeInstant, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sTimeInstant{}
	pc := propCommon{iri: iri, typ: "TimeInstant", model: mod}
	res.propCommon = pc
	mod.addTimeInstant(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sTimeInstant) makeMaps() {
	res.sTimeTemporalEntity.makeMaps()
	return
}

// addTimeInstant adds TimeInstant to model
func (mod *Model) addTimeInstant(res TimeInstant) {
	mod.mTimeInstant[res.IRI()] = res
	mod.addTimeTemporalEntity(res)
	return
}

// TimeInstant returns all resources with given prefix
func (mod *Model) TimeInstant(prefix string) (res []TimeInstant) {
	for i := range mod.mTimeInstant {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mTimeInstant[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sTimeInstant) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "http://www.w3.org/2006/time#inTemporalPosition":
		res.propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition.removeObject(obj)
	case "http://www.w3.org/2006/time#inDateTime":
		res.propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription.removeObject(obj)
	case "http://www.w3.org/2006/time#inTimePosition":
		res.propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition.removeObject(obj)
	default:
		res.sTimeTemporalEntity.RemoveObject(obj, prop)
	}
	return
}

// isTimeInstant indicates base class
func (res *sTimeInstant) IsTimeInstant() bool {
	return true
}

// InitFromNode initializes the resource from a graph node
func (res *sTimeInstant) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sTimeInstant) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "http://www.w3.org/2006/time#inXSDDateTimeStamp":
		res.propTimeInXSDDateTimeStampBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inXSDgYearMonth":
		res.propTimeInXSDgYearMonthBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inTemporalPosition":
		res.propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inXSDDateTime":
		res.propTimeInXSDDateTimeBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inXSDDate":
		res.propTimeInXSDDateBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inDateTime":
		res.propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inXSDgYear":
		res.propTimeInXSDgYearBaseGoTimeTypeGoTimeSingleGoTime.init(pred.Object.Term.String())
	case "http://www.w3.org/2006/time#inTimePosition":
		res.propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition.init(res.model, pred.Object.Term.String())
	default:
		res.sTimeTemporalEntity.propsInit(pred)
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sTimeInstant) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "http://www.w3.org/2006/time#Instant", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sTimeInstant) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.sTimeTemporalEntity.propsToGraph(node, g)
	res.propTimeInXSDDateTimeStampBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeInXSDgYearMonthBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition.toGraph(node, g)
	res.propTimeInXSDDateTimeBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeInXSDDateBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription.toGraph(node, g)
	res.propTimeInXSDgYearBaseGoTimeTypeGoTimeSingleGoTime.toGraph(node, g)
	res.propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sTimeInstant) String() (ret string) {
	ret = res.iri + " " + "TimeInstant\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sTimeInstant) propsString() (ret string) {
	ret = ""
	ret += res.sTimeTemporalEntity.propsString()
	ret += res.propTimeInXSDDateTimeStampBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeInXSDgYearMonthBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition.String()
	ret += res.propTimeInXSDDateTimeBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeInXSDDateBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription.String()
	ret += res.propTimeInXSDgYearBaseGoTimeTypeGoTimeSingleGoTime.String()
	ret += res.propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition.String()
	return
}


